# -*- coding: utf-8 -*-


import openerp.addons.decimal_precision as dp
from openerp import models, fields, api
from openerp.tools.float_utils import float_round as round, float_compare


class AccountPaymentTermLine(models.Model):
    _inherit = 'account.payment.term.line'

    interest_rate = fields.Float(string='Tasa de Interés',
                                 digits =dp.get_precision('Payment Term'),
                                 help="El interes mensual de cliente con atraso."
                                      "Valor de 0 a 100.\n"
                                      "El interes se calcula como: \n"
                                      "(Saldo Pendiente*(tasa de interes/100))")
